

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include <vga.h>

typedef unsigned char byte;

#define P 255
#define RAD2ANG (128/3.14159)

byte font[18][36]= {
	{ 0, 0, P, P, 0, 0 , \
	  0, P, 0, 0, P, 0 , \
 	  0, P, 0, P, P, 0 , \
	  0, P, P, 0, P, 0 , \
	  0, P, 0, 0, P, 0 , \
	  0, 0, P, P, 0, 0 },

	{ 0, 0, 0, P, 0, 0 , \
	  0, 0, P, P, 0, 0 , \
 	  0, 0, 0, P, 0, 0 , \
	  0, 0, 0, P, 0, 0 , \
	  0, 0, 0, P, 0, 0 , \
	  0, 0, 0, P, 0, 0 },
	  
	{ 0, 0, P, P, 0, 0 , \
	  0, P, 0, 0, P, 0 , \
 	  0, 0, 0, P, 0, 0 , \
	  0, 0, P, 0, 0, 0 , \
	  0, P, 0, 0, 0, 0 , \
	  0, P, P, P, P, 0 },

	{ 0, 0, P, P, 0, 0 , \
	  0, P, 0, 0, P, 0 , \
 	  0, 0, 0, P, 0, 0 , \
	  0, 0, 0, 0, P, 0 , \
	  0, P, 0, 0, P, 0 , \
	  0, 0, P, P, 0, 0 },

	  { 0, 0, 0, 0, P, 0 , \
	  0, 0, 0, P, P, 0 , \
 	  0, 0, P, 0, P, 0 , \
	  0, P, P, P, P, 0 , \
	  0, 0, 0, 0, P, 0 , \
	  0, 0, 0, 0, P, 0 },

	{ 0, P, P, P, P, 0 , \
	  0, P, 0, 0, 0, 0 , \
 	  0, P, P, P, 0, 0 , \
	  0, 0, 0, 0, P, 0 , \
	  0, P, 0, 0, P, 0 , \
	  0, 0, P, P, 0, 0 },

	{ 0, 0, P, P, 0, 0 , \
	  0, P, 0, 0, P, 0 , \
 	  0, P, 0, 0, 0, 0 , \
	  0, P, P, P, P, 0 , \
	  0, P, 0, 0, P, 0 , \
	  0, 0, P, P, 0, 0 },
	
	{ 0, P, P, P, P, 0 , \
	  0, P, 0, 0, P, 0 , \
	  0, 0, 0, P, 0, 0 , \
 	  0, 0, 0, P, 0, 0 , \
	  0, 0, P, 0, 0, 0 , \
	  0, 0, P, 0, 0, 0 , \
	  0, P, 0, 0, 0, 0 },
	  
	{ 0, 0, P, P, 0, 0 , \
	  0, P, 0, 0, P, 0 , \
 	  0, 0, P, P, 0, 0 , \
	  0, P, 0, 0, P, 0 , \
	  0, P, 0, 0, P, 0 , \
	  0, 0, P, P, 0, 0 },
	  
	{ 0, 0, P, P, 0, 0 , \
	  0, P, 0, 0, P, 0 , \
 	  0, 0, P, P, P, 0 , \
	  0, 0, 0, 0, P, 0 , \
	  0, P, 0, 0, P, 0 , \
	  0, 0, P, P, 0, 0 },

	{ 0, 0, P, P, 0, 0 , \
	  0, P, 0, 0, P, 0 , \
 	  0, P, P, P, P, 0 , \
	  0, P, 0, 0, P, 0 , \
	  0, P, 0, 0, P, 0 , \
	  0, P, 0, 0, P, 0 },


	{ 0, P, P, P, 0, 0 , \
	  0, P, 0, 0, P, 0 , \
 	  0, P, P, P, 0, 0 , \
	  0, P, 0, 0, P, 0 , \
	  0, P, 0, 0, P, 0 , \
	  0, P, P, P, 0, 0 },


	{ 0, 0, P, P, 0, 0 , \
	  0, P, 0, 0, P, 0 , \
 	  0, P, 0, 0, 0, 0 , \
	  0, P, 0, 0, 0, 0 , \
	  0, P, 0, 0, P, 0 , \
	  0, 0, P, P, 0, 0 },

	  
	{ 0, P, P, P, 0, 0 , \
	  0, P, 0, 0, P, 0 , \
 	  0, P, 0, 0, P, 0 , \
	  0, P, 0, 0, P, 0 , \
	  0, P, 0, 0, P, 0 , \
	  0, P, P, P, 0, 0 },


	{ 0, P, P, P, P, 0 , \
	  0, P, 0, 0, 0, 0 , \
 	  0, P, P, P, 0, 0 , \
	  0, P, 0, 0, 0, 0 , \
	  0, P, 0, 0, 0, 0 , \
	  0, P, P, P, P, 0 },

	{ 0, P, P, P, P, 0 , \
	  0, P, 0, 0, 0, 0 , \
 	  0, P, P, P, 0, 0 , \
	  0, P, 0, 0, 0, 0 , \
	  0, P, 0, 0, 0, 0 , \
	  0, P, 0, 0, 0, 0 },


	{ 0, P, 0, 0, P, 0 , \
	  P, P, P, P, P, P , \
 	  0, P, 0, 0, P, 0 , \
	  0, P, 0, 0, P, 0 , \
	  P, P, P, P, P, P , \
	  0, P, 0, 0, P, 0 },
	  
	{ 0, 0, 0, 0, 0, 0 , \
	  0, 0, 0, 0, 0, 0 , \
 	  0, 0, 0, 0, 0, 0 , \
	  0, P, P, P, P, 0 , \
	  0, 0, 0, 0, 0, 0 , \
	  0, 0, 0, 0, 0, 0 }
};


void letra(int x, int y, int letra) {

	int c, c2;

	for(c=0; c<6; c++)
		for(c2=0;c2<6; c2++)
			graph_mem[x+c2  + (y+c)*320] = font[letra][c2+c*6];

}

int main() {

	byte order=0, line=90, channel, line2;
	int c;
	unsigned int offset, frame=0;

	unsigned int x, y, x2, y2;

	

	byte pattern[64][4][3];
		
	vga_setmode(G320x200x256);


	for(c=0;c<64;c++)
		vga_setpalette(c, c/2, c/2, c/2);

	vga_setpalette(255, 255, 64, 64);

	while(1) {

			if(line>63) {

				order++;
				line=0;
	
				for(channel=0;channel<4;channel++) {
					for(line2=0;line2<64;line2++) {
						if(rand()>9000) {
							pattern[line2][channel][0]=(rand()%6)+10;
							pattern[line2][channel][1]=(rand()%2)+16;
							pattern[line2][channel][2]=(rand()%10);
						} else {
							pattern[line2][channel][0]=17;
							pattern[line2][channel][1]=17;
							pattern[line2][channel][2]=17;
						}
					}
				}

					
			}

			
			for(c=0;c<64000;c++)
				graph_mem[c]=0;

			for(channel=0;channel<4;channel++) {
				offset=50;
				for(line2=line;line2<line+64;line2++) {
					letra(channel*40+40, offset, pattern[line2][channel][0]);
					letra(channel*40+48, offset, pattern[line2][channel][1]);
					letra(channel*40+56, offset, pattern[line2][channel][2]);

					
					offset+=8;
					if(offset>=190 || line2>62 )
						break;
				
				}
			}

			letra( 10+30, 10, order>>4 );
			letra( 18+30, 10, order&0x0f );
			letra( 30+30, 10, line>>4 );
			letra( 38+30, 10, line&0x0f );
			
			line++;


			x=sin(frame/RAD2ANG)*64+160;
			y=cos(frame/RAD2ANG)*64+100;

			for(y2=0;y2<200;y2++)
				for(x2=0;x2<320;x2++)
					if(!graph_mem[x2+y2*320])
						graph_mem[x2+y2*320]=((byte)( (x2-x)*(x) + (y2-y) ))&63;

			frame+=10;
	
			for(c=0;c<5;c++)
			vga_waitretrace();
			
	}
	
		
	return 0;

}

